package BodyLengthListing::CMS;

use strict;

use MT;
use MT::ObjectAsset;
use MT::Asset;
use MT::Util;

sub add_css {
    my ($cb, $app, $template) = @_;

    my $q = $app->param;
    my $mode = $q->param('__mode');
    my $type = $q->param('_type');

    return if !($mode eq 'list' && ($type eq 'entry' || $type eq 'page'));

    my $col_width = 95;

    my $old;
    my $new;

    $old = <<HTML;
<mt:var name="html_head">
HTML
    $old = quotemeta($old);
    $new = <<HTML;
<style type="text/css">
.col.head.body_words {
    width: ${col_width}px;
}
</style>
  <mt:var name="html_head">
HTML

    $$template =~ s/$old/$new/;
}

sub html {
    my ( $prop, $obj, $app ) = @_;
    my $length = length( $obj->text );
    my $out = $length;
    return $out;
}

sub terms {
    my $prop = shift;
    my ( $args, $db_terms, $db_args, $opts ) = @_;

    my $val = $args->{value};

    my $app = MT->instance;
    my $option = $args->{option};

    my $blog = $app->blog;
    my $blog_id = $blog ? $blog->id : 0;
    if ($blog && !$blog->is_blog) {
        my $blogs = $blog->blogs;
        $blog_id = [ map { $_->id } @$blogs ];
    }

    my @entries = MT->model('entry')->load(
                           { ($blog_id) ? (blog_id => $blog_id) : (),
                             class => 'entry' },
                       );
    my @entry_ids;
    foreach my $entry (@entries) {

        if ( 'not_equal' eq $option ) {
            if ( length($entry->text) != $val ) {
                push @entry_ids, $entry->id;
            }
        } elsif ( 'greater_than' eq $option ) {
            if ( length($entry->text) > $val ) {
                push @entry_ids, $entry->id;
            }
        } elsif ( 'greater_equal' eq $option ) {
            if ( length($entry->text) >= $val ) {
                push @entry_ids, $entry->id;
            }
        } elsif ( 'less_than' eq $option ) {
            if ( length($entry->text) < $val ) {
                push @entry_ids, $entry->id;
            }
        } elsif ( 'less_equal' eq $option ) {
            if ( length($entry->text) <= $val ) {
                push @entry_ids, $entry->id;
            }
        }
    }
    return [
             { class => $prop->class },
             { id => scalar(@entry_ids) ? \@entry_ids : 0 }
        ];
}

sub bulk_sort {
    my $prop = shift;
    my ($objs) = @_;
    my %ids = map { $_->id => length( $_->text ) } @$objs;
    return sort {
        $ids{ $a->id } <=> $ids{ $b->id }
    } @$objs;
}

1;
